Package org.springframework.orm.hibernate5.support

# Class OpenSessionInViewFilter

java.lang.Object
org.springframework.web.filter.GenericFilterBean
org.springframework.web.filter.OncePerRequestFilter
org.springframework.orm.hibernate5.support.OpenSessionInViewFilter

All Implemented Interfaces:
  `Filter`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.context.EnvironmentAware`, `org.springframework.core.env.EnvironmentCapable`, `org.springframework.web.context.ServletContextAware`

public class OpenSessionInViewFilter extends org.springframework.web.filter.OncePerRequestFilter
Servlet Filter that binds a Hibernate Session to the thread for the entire processing of the request. Intended for the "Open Session in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

This filter makes Hibernate Sessions available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` as well as for non-transactional execution (if configured appropriately).

NOTE: This filter will by default not flush the Hibernate Session, with the flush mode set to `FlushMode.MANUAL`. It assumes to be used in combination with service layer transactions that care for the flushing: The active transaction manager will temporarily change the flush mode to `FlushMode.AUTO` during a read-write transaction, with the flush mode reset to `FlushMode.MANUAL` at the end of each transaction.

WARNING: Applying this filter to existing logic can cause issues that have not appeared before, through the use of a single Hibernate Session for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate Session has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

Looks up the SessionFactory in Spring's root web application context. Supports a "sessionFactoryBeanName" filter init-param in `web.xml`; the default bean name is "sessionFactory".

Since:
  4.2
Author:
  Juergen Hoeller
See Also:
  - `lookupSessionFactory(jakarta.servlet.http.HttpServletRequest)`
  - `OpenSessionInViewInterceptor`
  - `OpenSessionInterceptor`
  - `HibernateTransactionManager`
  - `TransactionSynchronizationManager`
  - `SessionFactory.getCurrentSession()`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_SESSION_FACTORY_BEAN_NAME`
The default bean name used for the session factory.

### Fields inherited from class org.springframework.web.filter.OncePerRequestFilter

`ALREADY_FILTERED_SUFFIX`

### Fields inherited from class org.springframework.web.filter.GenericFilterBean

`logger`

## Constructor Summary

Constructors
Constructor
Description
`OpenSessionInViewFilter()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)`
`protected String`
`getSessionFactoryBeanName()`
Return the bean name of the SessionFactory to fetch from Spring's root application context.
`protected SessionFactory`
`lookupSessionFactory()`
Look up the SessionFactory that this filter should use.
`protected SessionFactory`
`lookupSessionFactory(HttpServletRequest request)`
Look up the SessionFactory that this filter should use, taking the current HTTP request as argument.
`protected Session`
`openSession(SessionFactory sessionFactory)`
Open a Session for the SessionFactory that this filter uses.
`void`
`setSessionFactoryBeanName(String sessionFactoryBeanName)`
Set the bean name of the SessionFactory to fetch from Spring's root application context.
`protected boolean`
`shouldNotFilterAsyncDispatch()`
Returns "false" so that the filter may re-bind the opened Hibernate `Session` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.
`protected boolean`
`shouldNotFilterErrorDispatch()`
Returns "false" so that the filter may provide a Hibernate `Session` to each error dispatches.

### Methods inherited from class org.springframework.web.filter.OncePerRequestFilter

`doFilter, doFilterNestedErrorDispatch, getAlreadyFilteredAttributeName, isAsyncDispatch, isAsyncStarted, shouldNotFilter`

### Methods inherited from class org.springframework.web.filter.GenericFilterBean

`addRequiredProperty, afterPropertiesSet, createEnvironment, destroy, getEnvironment, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_SESSION_FACTORY_BEAN_NAME

public static final String DEFAULT_SESSION_FACTORY_BEAN_NAME
The default bean name used for the session factory.

See Also:
  - Constant Field Values

## Constructor Details

### OpenSessionInViewFilter

public OpenSessionInViewFilter()

## Method Details

### setSessionFactoryBeanName

public void setSessionFactoryBeanName(String sessionFactoryBeanName)
Set the bean name of the SessionFactory to fetch from Spring's root application context. Default is "sessionFactory".

See Also:
  - `DEFAULT_SESSION_FACTORY_BEAN_NAME`

### getSessionFactoryBeanName

protected String getSessionFactoryBeanName()
Return the bean name of the SessionFactory to fetch from Spring's root application context.

### shouldNotFilterAsyncDispatch

protected boolean shouldNotFilterAsyncDispatch()
Returns "false" so that the filter may re-bind the opened Hibernate `Session` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.

Overrides:
  `shouldNotFilterAsyncDispatch` in class `org.springframework.web.filter.OncePerRequestFilter`

### shouldNotFilterErrorDispatch

protected boolean shouldNotFilterErrorDispatch()
Returns "false" so that the filter may provide a Hibernate `Session` to each error dispatches.

Overrides:
  `shouldNotFilterErrorDispatch` in class `org.springframework.web.filter.OncePerRequestFilter`

### doFilterInternal

protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException

Specified by:
  `doFilterInternal` in class `org.springframework.web.filter.OncePerRequestFilter`
Throws:
  `ServletException`
  `IOException`

### lookupSessionFactory

protected SessionFactory lookupSessionFactory(HttpServletRequest request)
Look up the SessionFactory that this filter should use, taking the current HTTP request as argument.

The default implementation delegates to the `lookupSessionFactory()` variant without arguments.

Parameters:
  `request` - the current request
Returns:
  the SessionFactory to use

### lookupSessionFactory

protected SessionFactory lookupSessionFactory()
Look up the SessionFactory that this filter should use.

The default implementation looks for a bean with the specified name in Spring's root application context.

Returns:
  the SessionFactory to use
See Also:
  - `getSessionFactoryBeanName()`

### openSession

protected Session openSession(SessionFactory sessionFactory) throws org.springframework.dao.DataAccessResourceFailureException
Open a Session for the SessionFactory that this filter uses.

The default implementation delegates to the `SessionFactory.openSession()` method and sets the `Session`'s flush mode to "MANUAL".

Parameters:
  `sessionFactory` - the SessionFactory that this filter uses
Returns:
  the Session to use
Throws:
  `org.springframework.dao.DataAccessResourceFailureException` - if the Session could not be created
See Also:
  - `FlushMode.MANUAL`